Welcome!  This is a community for collaborating on creating great technical guides and tutorials.
Our collective aim is working together to educate the world while improving our knowledge at the same time.
Think of this as a "Wikipedia" for technical guides and tutorials, or "Medium.com for developers" as another analogy.

### Problems we’re trying to solve

- Technical blog content is currently created on WordPress, which isn't great for developers (doesn't easily support code blocks, etc).
- Once a guide is created, it becomes stale and out of date. If the author doesn’t maintain their content, then it becomes less useful.
- There isn’t a strong way for developers to improve their content through peer review.  Wordpress isn't great for that.
- Guides currently exist in silos.  They live on individual blogs, and are fragmented and varying in quality.  Those guides don't typically reach a wide audience since individual blogs have limited reach.
- Programming guides are largely in English and do not translate quickly/easily into other languages since code isn’t easily auto-translated.  Other countries don’t have easy access to learning.

### How we’re solving these problems together

- **We use [MarkDown](http://daringfireball.net/projects/markdown/basics)** (rather than WordPress), a simple file format.  This is a really simple text-based file format that takes around 60 seconds to understand.  It's really easy to make things **bold**, _italics_, `code blocks`, etc.  Markdown is used in many places, such as Github README files.  Even this file is a Markdown file.  You can help us edit and improve it.
- **The guides are stored in GitHub**, which many developers use daily and love.
- **Use your favorite text editor** to create tutorials and **check them in via Git**.  Or you can also edit tutorials using Github's UI.  **Way better than Wordpress**.
- If you aren't familiar with git/Github, or don't want to bother with that, that's fine too -- we have a handy-dandy visual editor on our site to edit tutorials right here.
- **The code for this site is open-sourced in Github**.  Let's improve it together!
- You can get your tutorials **peer-reviewed by others**.  This improves the quality of our collective knowledge.
- **Others can help maintain your tutorials long-term**, making the content have a much deeper longevity when updates are needed, and removes the original author as a single point of failure if you get busy and can't maintain your tutorial.
- **We can help each other reach a wide audience and make a bigger impact**.  When a tutorial gets published, we all work together to help promote it on HackerNews, to get lots of viewers.  By building momentum on this site together, we'll get a larger audience over time, which means your tutorials will reach a wide audience.
- (Future) **Bring knowledge to other countries**.  Your content can be translated by a community of bilingual individuals who are passionate about their countries receiving knowledge. Thanks to their translating efforts, the guides and tutorials can be shared with countries who don't have a deep understanding of the English language.

### Some bonus reasons to contribute a tutorial here!
* **Help the world**.  You'll help spread useful knowledge.
* **Free subscription to Pluralsight.com**.  Pluralsight is our corporate sponsor for this project and is subsidizing the costs of some of the open-source development.  We've negotiated with Pluralsight to give all contributors a free subscription to their video library on training for programmers, so you can stay up-to-date on all programming topics.  This is worth $299.
* **Network with other important members of the community**.  We'll give you access to our <a href="https://hackguides.herokuapp.com" target="_blank">Slack community</a>, to make awesome connections with others who are involved.
* **Free access to the next hack.summit() conference for you and your friends**.  Get your own special code you can give out!

### Who owns the tutorials created here?

You do, as the original author.  This site is a venue for your content to be maintained in a much better way than Wordpress, and to reach a wider audience.  But we don't own your content.  In fact, if you really want to, you can host a copy of this website yourself since everything is open-source.

### What types of tutorials are appropriate to post?

*Feel free to write about any technology that you're passionate about.* Generally speaking, one of the following:

* Tutorial on programming with X (where X is a technology or library you’re passionate about)
* Top 10 things you probably didn’t know about X
* Guide to what’s new in the latest version of X
* Advanced guide to programming with X
* Top 10 tips when programming with X
* X vs Y [where Y is a competing technology or is no technology]

...or any other ideas you might have.  Please reach out to Prateek (prateek-gupta@pluralsight.com)! :)

### How long should tutorials be?

Tutorials/articles ideally range from 1500-3000 words, including `code blocks`, to be a 'definitive tutorial' on a technical subject.

### Can you help me edit/revise the article?
Yes! That's why we've built the editing tools on this site. It's easy to share a link to your article on social media and crowdsource expert-level editors for your topics. You'll be able to see suggestions from the community and accept the changes you want. Our editors can help improve it too.

### Can I hang out with you on your Slack?

Absolutely! Join our <a href="https://hackguides.herokuapp.com" target="_blank">Slack community</a>, we want as much feedback as possible.

### How else can I help?

* Fill out <a href="https://hackguides.typeform.com/to/EwVks9" target="_blank">this quick form</a> to let us know what you're interested in
* Volunteer to be an editor to help others improve content
* Make some engine contributions to the open-source engine for the site
* Spread the word about the site on twitter, facebook, HackerNews, etc.
* Volunteer to be a translator to help us bring content to other spoken languages

Please reach out to Prateek (prateek-gupta@pluralsight.com) if you want to chat about any of this, or ping us on our Slack!

### How do I know if my tutorial idea is any good?
One easy thing you can do is to check-out what else is out there for this particular subject. Try doing a quick search now for some topics that interest you. Other articles are generally OK so long as there is enough unique/useful content that sets your article apart. Are there ideas you can talk about in your proposed article that hasn't already been written? Enough interesting unique contributions that can be added that move the world's knowledge forward? Those are some things to think about.

### What is the writing process?
1. [Submit a tutorial](/write/)
2. Share a link for suggestions to your article with friends, co-workers, etc.
3. Continue improving your article with the community help
4. Our editors will also assist you with improving your article
5. Publish your article!
